VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Changes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" _
Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal _
Length As Long)

Dim change() As Long
Dim curpos As Long

Function UBnd() As Long
    UBnd = UBound(change)
End Function

Private Sub Class_Initialize()
    ReDim change(100)
    curpos = 0
    
End Sub

Sub AddChange(x As Integer, y As Integer, value As Integer)
    If curpos > UBound(change) Then
        ReDim Preserve change(UBound(change) + 1000)
    End If
    
    Dim reb(3) As Byte
    reb(0) = x Mod 256 'bottom 8 of x
    reb(2) = y \ 16 'top 8 of y
    'calculate b(1) out of y, but add the remainder from the x
    'equation because when y is calculated, it's rounded
    'down and the remainder is lost
    reb(1) = (y - 16 * reb(2)) * 16 + (x - reb(0)) / 256
    If value = -1 Then
        reb(3) = 0
    Else
        reb(3) = CByte(value)
    End If
    
    change(curpos) = BytesToNumEx(reb, 0, 3, False)

    curpos = curpos + 1
End Sub

Function GetChange(index As Long) As Integer()
    Dim ret(2) As Integer
    Dim b() As Byte
    b = LongToByteArray(change(index))
    
    ret(0) = b(0) + 256 * (b(1) Mod 16)
    ret(1) = b(1) \ 16 + 16 * b(2)
    
    ret(2) = b(3)

    GetChange = ret
End Function

Function LongToByteArray(ByVal lng As Long) As Byte()

'Example:
'dim bytArr() as Byte
'dim iCtr as Integer
'bytArr = LongToByteArray(90121)
'For iCtr = 0 to Ubound(bytArr)
   'Debug.Print bytArr(iCtr)
'Next
'******************************************
Dim ByteArray(0 To 3) As Byte
CopyMemory ByteArray(0), ByVal VarPtr(lng), Len(lng)
LongToByteArray = ByteArray

End Function

Function BytesToNumEx(ByteArray() As Byte, StartRec As Long, _
   EndRec As Long, UnSigned As Boolean) As Double
' ###################################################
' Author                : Imran Zaheer
' Contact               : imraanz@mail.com
' Date                  : January 2000
' Function BytesToNumEx : Convertes the specified byte array
'                         into the corresponding Integer or Long
'                         or any signed/unsigned
'                        ;(non-float) data type.
'
' * BYTES : LIKE NUMBERS(Integer/Long etc.) STORED IN A
' * BINARY FILE

' Parameters :
'  (All parameters are reuuired: No Optional)
'     ByteArray() : byte array containg a number in byte format
'  StartRec    : specify the starting array record within the
                 ' array
'     EndRec      : specify the end array record within the array
'     UnSigned    : when False process bytes for both -ve and
'                   +ve values.
'                   when true only process the bytes for +ve
'                   values.
'
' Note: If both "StartRec" and "EndRec" Parameters are zero,
'       then the complete array will be processed.
'
' Example Calls :
'      dim myArray(1 To 4) as byte
'      dim myVar1 as Integer
'      dim myVar2 as Long
'
'      myArray(1) = 255
'      myArray(2) = 127
'      myVar1 = BytesToNumEx(myArray(), 1, 2, False)
'  after execution of above statement myVar1 will be 32767
'
'      myArray(1) = 0
'      myArray(2) = 0
'      myArray(3) = 0
'      myArray(4) = 128
'      myVar2 = BytesToNumEx(myArray(), 1, 4, False)
'  after execution of above statement myVar2 will be -2147483648
'
'
'####################################################
On Error GoTo ErrorHandler
Dim i As Integer
Dim lng256 As Double
Dim lngReturn As Double
    
    lng256 = 1
    lngReturn = 0
    
    If EndRec < 1 Then
        EndRec = UBound(ByteArray)
    End If
    
    If StartRec > EndRec Or StartRec < 0 Then
        MsgBox _
         "Start record can not be greater then End record...!", _
          vbInformation
        BytesToNumEx = -1
        Exit Function
    End If
    
    lngReturn = lngReturn + (ByteArray(StartRec))
    For i = (StartRec + 1) To EndRec
        lng256 = lng256 * 256
        If i < EndRec Then
            lngReturn = lngReturn + (ByteArray(i) * lng256)
        Else
           ' if -ve

            If ByteArray(i) > 127 And UnSigned = False Then
             lngReturn = (lngReturn + ((ByteArray(i) - 256) _
                  * lng256))
            Else
                lngReturn = lngReturn + (ByteArray(i) * lng256)
            End If
        End If
    Next i
    
    BytesToNumEx = lngReturn
ErrorHandler:
End Function

